package com.qmth.distributed.print.business.bean.result.statistics;

import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import com.qmth.distributed.print.business.enums.CardTypeEnum;
import com.qmth.distributed.print.business.enums.StatisticsStatusEnum;
import io.swagger.annotations.ApiModelProperty;

import java.io.Serializable;
import java.util.Objects;

/**
 * @Description: 命题任务统计 result
 * @Param:
 * @return:
 * @Author: wangliang
 * @Date: 2024/7/10
 */
public class StatementResult implements Serializable {

    @ApiModelProperty(value = "主键")
    @JsonSerialize(using = ToStringSerializer.class)
    private Long id;

    @ApiModelProperty(value = "课程名称（代码）")
    private String courseNameCode;

    @ApiModelProperty(value = "试卷编号")
    private String paperNumber;

    @ApiModelProperty(value = "题卡id")
    @JsonSerialize(using = ToStringSerializer.class)
    private Long cardId;

    @ApiModelProperty(value = "开课学院")
    private String college;

    @ApiModelProperty(value = "总考场数")
    private Integer totalExamination;

    @ApiModelProperty(value = "已生成")
    private Integer generate;

    @ApiModelProperty(value = "未生成")
    private Integer unGenerated;

    @ApiModelProperty(value = "已印刷")
    private Integer printed;

    @ApiModelProperty(value = "未印刷")
    private Integer unPrinted;

    @ApiModelProperty(value = "已作废")
    private Integer invalid;

    @ApiModelProperty(value = "已打回")
    private Integer reject;

    @ApiModelProperty(value = "题卡类型")
    private CardTypeEnum cardType;

    @ApiModelProperty(value = "题卡类型str")
    private String cardTypeStr;

    @ApiModelProperty(value = "状态，FINISH：已完成，UN_FINISH：未完成")
    private StatisticsStatusEnum finishStatus;

    @ApiModelProperty(value = "题卡类型str")
    private String finishStatusStr;

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getCourseNameCode() {
        return courseNameCode;
    }

    public void setCourseNameCode(String courseNameCode) {
        this.courseNameCode = courseNameCode;
    }

    public String getPaperNumber() {
        return paperNumber;
    }

    public void setPaperNumber(String paperNumber) {
        this.paperNumber = paperNumber;
    }

    public Long getCardId() {
        return cardId;
    }

    public void setCardId(Long cardId) {
        this.cardId = cardId;
    }

    public String getCollege() {
        return college;
    }

    public void setCollege(String college) {
        this.college = college;
    }

    public Integer getTotalExamination() {
        return totalExamination;
    }

    public void setTotalExamination(Integer totalExamination) {
        this.totalExamination = totalExamination;
    }

    public Integer getGenerate() {
        return generate;
    }

    public void setGenerate(Integer generate) {
        this.generate = generate;
    }

    public Integer getUnGenerated() {
        return unGenerated;
    }

    public void setUnGenerated(Integer unGenerated) {
        this.unGenerated = unGenerated;
    }

    public Integer getPrinted() {
        return printed;
    }

    public void setPrinted(Integer printed) {
        this.printed = printed;
    }

    public Integer getUnPrinted() {
        return unPrinted;
    }

    public void setUnPrinted(Integer unPrinted) {
        this.unPrinted = unPrinted;
    }

    public Integer getInvalid() {
        return invalid;
    }

    public void setInvalid(Integer invalid) {
        this.invalid = invalid;
    }

    public Integer getReject() {
        return reject;
    }

    public void setReject(Integer reject) {
        this.reject = reject;
    }

    public CardTypeEnum getCardType() {
        return cardType;
    }

    public void setCardType(CardTypeEnum cardType) {
        this.cardType = cardType;
    }

    public String getCardTypeStr() {
        return Objects.nonNull(cardType) ? cardType.getName() : cardTypeStr;
    }

    public void setCardTypeStr(String cardTypeStr) {
        this.cardTypeStr = cardTypeStr;
    }

    public StatisticsStatusEnum getFinishStatus() {
        return finishStatus;
    }

    public void setFinishStatus(StatisticsStatusEnum finishStatus) {
        this.finishStatus = finishStatus;
    }

    public String getFinishStatusStr() {
        return Objects.nonNull(finishStatus) ? finishStatus.getTitle() : finishStatusStr;
    }

    public void setFinishStatusStr(String finishStatusStr) {
        this.finishStatusStr = finishStatusStr;
    }
}
